﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ExamProg
{
    public class MinElem //Класс, в котором содержится математическое решение задачи минимального элемента
    {
        int[] arrN = new int[3];
        int[] arrM = new int[3];
        int[,] Arr = new int[3, 3];
        int[,] FinalArr = new int[3, 3];
        string path = "MinElem.scv";
        string pathExit = "Answer.txt";

        public MinElem() // конструктор для заполнения полей этого класса
        {
            using (StreamReader reader = new StreamReader($"Data/{path}"))
            {
                string temp;
                temp = reader.ReadLine();
                string[] strings = temp.Split(';');

                for (int i = 0; i < strings.Length; i++)
                {
                    this.arrN[i] = Convert.ToInt32(strings[i]);
                }

                temp = reader.ReadLine();
                strings = temp.Split(';');

                for (int i = 0; i < strings.Length; i++)
                {
                    this.arrM[i] = Convert.ToInt32(strings[i]);
                }

                int k = 0;

                while ((temp = reader.ReadLine()) != null)
                {
                    strings = temp.Split(';');

                    for (int i = 0; i < strings.Length; i++)
                    {
                        this.Arr[k, i] = Convert.ToInt32(strings[i]);
                    }

                    k++;
                }
            }
        }

        int FindMin(int[,] arr, int rows, int columns) //поиск минимального элемента в массиве
        {
            int min = 100;

            for (int i = 0; i < columns; i++)
            {
                for (int j = 0; j < rows; j++)
                {
                    if (min > arr[i, j])
                    {
                        min = arr[i, j];
                    }
                }
            }

            return min;
        }

        int TestSum(int[] arr) //сумма элементов одномерного массива (для проверки равности сумм спроса и предложения)
        {
            int sum = 0;

            for (int i = 0; i < arr.Length; i++)
            {
                sum += arr[i];
            }

            return sum;
        }

        int Method() //метод для решения задачи минимального элемента
        {
            int f = 0;

            int rows = Arr.GetUpperBound(0) + 1;
            int columns = Arr.Length / rows;

            if (TestSum(arrN) == TestSum(arrM))
            {
                while (TestSum(arrN) + TestSum(arrM) != 0)
                {
                    int min = FindMin(Arr, rows, columns);

                    for (int i = 0; i < columns; i++)
                    {
                        for (int j = 0; j < rows; j++)
                        {
                            if (Arr[i, j] == min)
                            {
                                if (arrN[j] < arrM[i])
                                {
                                    f += Arr[i, j] * arrN[j];
                                    Arr[i, j] = 100;
                                    FinalArr[i, j] = arrN[j];
                                    arrM[i] -= arrN[j];
                                    arrN[j] = 0;

                                }
                                else if (arrN[j] > arrM[i])
                                {
                                    f += Arr[i, j] * arrM[i];
                                    Arr[i, j] = 100;
                                    FinalArr[i, j] = arrM[i];
                                    arrN[j] -= arrM[i];
                                    arrM[i] = 0;
                                }
                                else
                                {
                                    f += Arr[i, j] * arrN[j];
                                    Arr[i, j] = 100;
                                    FinalArr[i, j] = arrN[j];
                                    arrM[i] = 0;
                                    arrN[j] = 0;
                                }
                            }
                        }
                    }
                }
            }

            return f;
        }

        public void Answer() //вывод ответа в файл
        {
            using (StreamWriter writer = new StreamWriter($"Data/{pathExit}"))
            {
                writer.WriteLine($"Весь путь затратит {Method()} условно денежных единиц");
            }
        }
    }
}
